#!/usr/local/bin/ruby
class Animal_de_Cuatro_Patas  
   def initialize(nombre, color)
     if nombre == ""
       @nombre = "un #{self.class} sin_nombre"
     else
       @nombre = nombre
     end

     if color == ""
       @color = default_color # Igual que self.default_color
     else
       @color = color
     end
   end

   def habla
     print @nombre, " dice :  ...", sound, "\n"
   end

   def come(alimento)
     @alimento = alimento
     print @nombre, " come ", alimento, "\n"
   end

   def default_color; " azabache "; end

   def muestra_color
     print self.class, ": ",  @nombre, " tiene color #{@color}!\n"
   end
 end


 class Caballo < Animal_de_Cuatro_Patas
   def sound; "Hoy Trabajar ms duro...."; end
 end


 class Oveja < Animal_de_Cuatro_Patas
   def sound; "Dos patas Si, Cuatro Patas No"; end
   def default_color; "blanco"; end
 end

 unaOveja = Oveja.new( "Oveja_Rasurada", "negro")
 unaOveja.muestra_color
 unaOveja.habla

pequenaOveja = Oveja.new( "", "")
pequenaOveja.muestra_color
pequenaOveja.habla

 otraOveja = Oveja.new( "Oveja_Sin_Lana", "") # Usa el Color de defecto de la Oveja 
 otraOveja.muestra_color
 otraOveja.come("Pasto")

 unCaballo = Caballo.new("","") # Usa el Color de Default del Animal_de_Cuatro_Patas
 unCaballo.muestra_color
 unCaballo.habla
 
 otroCaballo = Caballo.new("Boxer","caf") # Usa el Color de Default del  Animal_de_Cuatro_Patas
 otroCaballo.muestra_color
 otroCaballo.come("Alfalfa")


